/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.35
        Device            :  PIC16F1825
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set PGD aliases
#define PGD_TRIS               TRISAbits.TRISA0
#define PGD_LAT                LATAbits.LATA0
#define PGD_PORT               PORTAbits.RA0
#define PGD_WPU                WPUAbits.WPUA0
#define PGD_ANS                ANSELAbits.ANSA0
#define PGD_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define PGD_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define PGD_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define PGD_GetValue()           PORTAbits.RA0
#define PGD_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define PGD_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define PGD_SetPullup()      do { WPUAbits.WPUA0 = 1; } while(0)
#define PGD_ResetPullup()    do { WPUAbits.WPUA0 = 0; } while(0)
#define PGD_SetAnalogMode()  do { ANSELAbits.ANSA0 = 1; } while(0)
#define PGD_SetDigitalMode() do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set PGC aliases
#define PGC_TRIS               TRISAbits.TRISA1
#define PGC_LAT                LATAbits.LATA1
#define PGC_PORT               PORTAbits.RA1
#define PGC_WPU                WPUAbits.WPUA1
#define PGC_ANS                ANSELAbits.ANSA1
#define PGC_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define PGC_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define PGC_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define PGC_GetValue()           PORTAbits.RA1
#define PGC_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define PGC_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define PGC_SetPullup()      do { WPUAbits.WPUA1 = 1; } while(0)
#define PGC_ResetPullup()    do { WPUAbits.WPUA1 = 0; } while(0)
#define PGC_SetAnalogMode()  do { ANSELAbits.ANSA1 = 1; } while(0)
#define PGC_SetDigitalMode() do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set TXEN aliases
#define TXEN_TRIS               TRISAbits.TRISA2
#define TXEN_LAT                LATAbits.LATA2
#define TXEN_PORT               PORTAbits.RA2
#define TXEN_WPU                WPUAbits.WPUA2
#define TXEN_ANS                ANSELAbits.ANSA2
#define TXEN_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define TXEN_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define TXEN_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define TXEN_GetValue()           PORTAbits.RA2
#define TXEN_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define TXEN_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define TXEN_SetPullup()      do { WPUAbits.WPUA2 = 1; } while(0)
#define TXEN_ResetPullup()    do { WPUAbits.WPUA2 = 0; } while(0)
#define TXEN_SetAnalogMode()  do { ANSELAbits.ANSA2 = 1; } while(0)
#define TXEN_SetDigitalMode() do { ANSELAbits.ANSA2 = 0; } while(0)

// get/set SWIN aliases
#define SWIN_TRIS               TRISAbits.TRISA3
#define SWIN_PORT               PORTAbits.RA3
#define SWIN_WPU                WPUAbits.WPUA3
#define SWIN_GetValue()           PORTAbits.RA3
#define SWIN_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define SWIN_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define SWIN_SetPullup()      do { WPUAbits.WPUA3 = 1; } while(0)
#define SWIN_ResetPullup()    do { WPUAbits.WPUA3 = 0; } while(0)

// get/set VIN11 aliases
#define VIN11_TRIS               TRISAbits.TRISA4
#define VIN11_LAT                LATAbits.LATA4
#define VIN11_PORT               PORTAbits.RA4
#define VIN11_WPU                WPUAbits.WPUA4
#define VIN11_ANS                ANSELAbits.ANSA4
#define VIN11_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define VIN11_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define VIN11_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define VIN11_GetValue()           PORTAbits.RA4
#define VIN11_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define VIN11_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define VIN11_SetPullup()      do { WPUAbits.WPUA4 = 1; } while(0)
#define VIN11_ResetPullup()    do { WPUAbits.WPUA4 = 0; } while(0)
#define VIN11_SetAnalogMode()  do { ANSELAbits.ANSA4 = 1; } while(0)
#define VIN11_SetDigitalMode() do { ANSELAbits.ANSA4 = 0; } while(0)

// get/set STAT aliases
#define STAT_TRIS               TRISAbits.TRISA5
#define STAT_LAT                LATAbits.LATA5
#define STAT_PORT               PORTAbits.RA5
#define STAT_WPU                WPUAbits.WPUA5
#define STAT_SetHigh()            do { LATAbits.LATA5 = 1; } while(0)
#define STAT_SetLow()             do { LATAbits.LATA5 = 0; } while(0)
#define STAT_Toggle()             do { LATAbits.LATA5 = ~LATAbits.LATA5; } while(0)
#define STAT_GetValue()           PORTAbits.RA5
#define STAT_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define STAT_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define STAT_SetPullup()      do { WPUAbits.WPUA5 = 1; } while(0)
#define STAT_ResetPullup()    do { WPUAbits.WPUA5 = 0; } while(0)

// get/set SCL aliases
#define SCL_TRIS               TRISCbits.TRISC0
#define SCL_LAT                LATCbits.LATC0
#define SCL_PORT               PORTCbits.RC0
#define SCL_WPU                WPUCbits.WPUC0
#define SCL_ANS                ANSELCbits.ANSC0
#define SCL_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define SCL_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define SCL_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define SCL_GetValue()           PORTCbits.RC0
#define SCL_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define SCL_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define SCL_SetPullup()      do { WPUCbits.WPUC0 = 1; } while(0)
#define SCL_ResetPullup()    do { WPUCbits.WPUC0 = 0; } while(0)
#define SCL_SetAnalogMode()  do { ANSELCbits.ANSC0 = 1; } while(0)
#define SCL_SetDigitalMode() do { ANSELCbits.ANSC0 = 0; } while(0)

// get/set SDA aliases
#define SDA_TRIS               TRISCbits.TRISC1
#define SDA_LAT                LATCbits.LATC1
#define SDA_PORT               PORTCbits.RC1
#define SDA_WPU                WPUCbits.WPUC1
#define SDA_ANS                ANSELCbits.ANSC1
#define SDA_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define SDA_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define SDA_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define SDA_GetValue()           PORTCbits.RC1
#define SDA_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define SDA_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define SDA_SetPullup()      do { WPUCbits.WPUC1 = 1; } while(0)
#define SDA_ResetPullup()    do { WPUCbits.WPUC1 = 0; } while(0)
#define SDA_SetAnalogMode()  do { ANSELCbits.ANSC1 = 1; } while(0)
#define SDA_SetDigitalMode() do { ANSELCbits.ANSC1 = 0; } while(0)

// get/set SDO aliases
#define SDO_TRIS               TRISCbits.TRISC2
#define SDO_LAT                LATCbits.LATC2
#define SDO_PORT               PORTCbits.RC2
#define SDO_WPU                WPUCbits.WPUC2
#define SDO_ANS                ANSELCbits.ANSC2
#define SDO_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define SDO_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define SDO_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define SDO_GetValue()           PORTCbits.RC2
#define SDO_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define SDO_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define SDO_SetPullup()      do { WPUCbits.WPUC2 = 1; } while(0)
#define SDO_ResetPullup()    do { WPUCbits.WPUC2 = 0; } while(0)
#define SDO_SetAnalogMode()  do { ANSELCbits.ANSC2 = 1; } while(0)
#define SDO_SetDigitalMode() do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set IO_RC3 aliases
#define IO_RC3_TRIS               TRISCbits.TRISC3
#define IO_RC3_LAT                LATCbits.LATC3
#define IO_RC3_PORT               PORTCbits.RC3
#define IO_RC3_WPU                WPUCbits.WPUC3
#define IO_RC3_ANS                ANSELCbits.ANSC3
#define IO_RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define IO_RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define IO_RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define IO_RC3_GetValue()           PORTCbits.RC3
#define IO_RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define IO_RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define IO_RC3_SetPullup()      do { WPUCbits.WPUC3 = 1; } while(0)
#define IO_RC3_ResetPullup()    do { WPUCbits.WPUC3 = 0; } while(0)
#define IO_RC3_SetAnalogMode()  do { ANSELCbits.ANSC3 = 1; } while(0)
#define IO_RC3_SetDigitalMode() do { ANSELCbits.ANSC3 = 0; } while(0)

// get/set BTRX aliases
#define BTRX_TRIS               TRISCbits.TRISC4
#define BTRX_LAT                LATCbits.LATC4
#define BTRX_PORT               PORTCbits.RC4
#define BTRX_WPU                WPUCbits.WPUC4
#define BTRX_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define BTRX_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define BTRX_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define BTRX_GetValue()           PORTCbits.RC4
#define BTRX_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define BTRX_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define BTRX_SetPullup()      do { WPUCbits.WPUC4 = 1; } while(0)
#define BTRX_ResetPullup()    do { WPUCbits.WPUC4 = 0; } while(0)

// get/set BTTX aliases
#define BTTX_TRIS               TRISCbits.TRISC5
#define BTTX_LAT                LATCbits.LATC5
#define BTTX_PORT               PORTCbits.RC5
#define BTTX_WPU                WPUCbits.WPUC5
#define BTTX_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define BTTX_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define BTTX_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define BTTX_GetValue()           PORTCbits.RC5
#define BTTX_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define BTTX_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define BTTX_SetPullup()      do { WPUCbits.WPUC5 = 1; } while(0)
#define BTTX_ResetPullup()    do { WPUCbits.WPUC5 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/